 1000 REM****************************************************************************
 1010 REM-------------------------- S O L I T A I R E - 3 ---------------------------
 1020 REM------------- Copyright (C) 2000-2007 by Bob Seguin (Freeware) -------------
 1030 REM--------------------- Ported to SBASIC by Dominique Ezvan ------------------
 1040 REM****************************************************************************
 1050 REM PlayType
 1060 DIM MAINPLAY_SUIT%(7,18)
 1070 DIM MAINPLAY_VALUE%(7,18)
 1080 DIM MAINPLAY_X%(7,18)
 1090 DIM MAINPLAY_Y%(7,18)
 1100 DIM MAINPLAY_UPDOWN%(7,18)
 1110 REM DeckType
 1120 DIM DECKS_SUIT%(3,8)
 1130 DIM DECKS_VALUE%(3,8)
 1140 DIM TURNUPS_SUIT%(24)
 1150 DIM TURNUPS_VALUE%(24)
 1160 DIM STACKS_SUIT%(4)
 1170 DIM STACKS_VALUE%(4)
 1180 DIM TRICK_SUIT%(18)
 1190 DIM TRICK_VALUE%(18)
 1200 REM
 1210 DIM BUTTONS$(3)
 1220 DIM CARD$(55)
 1230 DIM SUITS$(3)
 1240 DIM NUMBERS$(21)
 1250 DIM MENUGFX$(4)
 1260 DIM DECK%(52)
 1270 REM****************************************************************************
 1280 OPEN OLD "sol3opts.dat" AS 1
 1290 INPUT #1, VEGAS%, MONEY%
 1300 CLOSE 1
 1310 FOR I%=0 TO 3
 1320  BLOAD "sol3suit"+LTRIM$(RTRIM$(STR$(I%)))+".bmp" SUITS$(I%)
 1330 NEXT I%
 1340 FOR I%=0 TO 2
 1350  BLOAD "sol3btns"+LTRIM$(RTRIM$(STR$(I%)))+".bmp" BUTTONS$(I%)
 1360 NEXT I%
 1370 BLOAD "sol3titl.bmp" TITLE$
 1380 BLOAD "sol3cd53.bmp" CARDBACK$
 1390 BLOAD "sol3cd54.bmp" BACKERASE$
 1400 BLOAD "sol3sele.bmp" SELECTED$
 1410 BLOAD "sol3topp.bmp" TPOFF$
 1420 BLOAD "sol3chek.bmp" CHEK$
 1430 FOR I%=0 TO 21
 1440  BLOAD "sol3nums"+LTRIM$(RTRIM$(STR$(I%)))+".bmp" NUMBERS$(I%)
 1450 NEXT I%
 1460 FOR I%=0 TO 4
 1470  BLOAD "sol3men1"+LTRIM$(RTRIM$(STR$(I%)))+".bmp" MENUGFX$(I%)
 1480 NEXT I%
 1490 FOR I%=1 TO 55
 1500  BLOAD "sol3cd"+LTRIM$(RTRIM$(STR$(I%)))+".bmp" CARD$(I%)
 1510 NEXT I%
 1520 REM
 1530 GR 640,480
 1540 GOSUB PALETTESET
 1550 COLOR 14 : CLRG
 1560 CALL DISPSCREEN(1)
 1570 GOSUB INITVALS
 1580 GOSUB SOL3DEAL
 1590 REM
 1600 LABEL MAINLOOP
 1610  GOSUB MOUSESTATUS
 1620  IF MENU% > 2 THEN CALL SOL3MENU(1) : GOTO MAINLOOP3
 1630  IF MOUSEY% >= 18 GOTO MAINLOOP1
 1640   IF MOUSEX% > 621 AND LB% THEN GOTO CHECKOUT
 1650   IF MENU% THEN CALL SOL3MENU(0)
 1660   GOTO MAINLOOP3
 1670 LABEL MAINLOOP1
 1680  IF MOUSEY% < 20 OR MOUSEY% > 35 GOTO MAINLOOP2
 1690   IF MOUSEX% < 103 THEN CALL SOL3MENU(1) : GOTO MAINLOOP3
 1700   IF MENU% THEN CALL SOL3MENU(0)
 1710   GOTO MAINLOOP3
 1720 LABEL MAINLOOP2
 1730  IF MOUSEY% <= 38 GOTO MAINLOOP3
 1740   IF MENU% THEN CALL SOL3MENU(0)
 1750   GOSUB GAME
 1760   GOSUB FINITO
 1770 LABEL MAINLOOP3
 1780 GOSUB MOUSEPAUSE
 1790 GOTO MAINLOOP
 1800 REM**************************************************************************** 
 1810 LABEL PALETTESET
 1820 DATA 0,0,0,16,16,32,21,63,21,63,63,0
 1830 DATA 63,0,0,28,28,28,0,34,0,63,50,10
 1840 DATA 0,30,55,45,50,63,0,63,63,0,42,0
 1850 DATA 63,45,55,63,30,40,48,48,48,63,63,63
 1860 FOR N% = 0 TO 15
 1870  READ R%, G%, B%
 1880  SETCOLOR N%, R% * 4 + R% / 16, G% * 4 + G% / 16, B% * 4 + B% / 16
 1890 NEXT N%
 1900 RETURN
 1910 REM**************************************************************************** 
 1920 LABEL CHECKOUT
 1930 CALL BOXPUT(BUTTONS$(2), 622, 2, 0)
 1940 CALL PAUSE(.1)
 1950 CALL BOXPUT(BUTTONS$(0), 588, 2, 0)
 1960 CALL PAUSE(.1)
 1970 CLEAR
 1980 END
 1990 REM**************************************************************************** 
 2000 LABEL CHECKTOTAL
 2010 IF VEGAS% <> 0 OR DECK1% <> 0 OR DECK2% <> 0 OR DECK3% <> 0 THEN RETURN
 2020 IF DECK4% > 0 THEN DECK1% = DECK4% : CALL BOXPUT(CARDBACK$, 5, 43, 0)
 2030 IF DECK4% > 8 THEN DECK1% = 8 : DECK2% = DECK4% - 8 : CALL BOXPUT(CARDBACK$, 83, 43, 0)
 2040 IF DECK4% > 16 THEN DECK1% = 8 : DECK2% = 8 : DECK3% = DECK4% - 16 : CALL BOXPUT(CARDBACK$, 161, 43, 0)
 2050 CALL DRWBLOCK(239, 43, 313, 152, 11)
 2060 IF DECK3% = 0 GOTO CHECKTOTAL1
 2070 FOR N% = 1 TO DECK3%
 2080  DECKS_VALUE%(3, N%) = TURNUPS_VALUE%(DECK4%)
 2090  DECKS_SUIT%(3, N%) = TURNUPS_SUIT%(DECK4%)
 2100  DECK4% = DECK4% - 1
 2110 NEXT N%
 2120 LABEL CHECKTOTAL1
 2130 IF DECK2% = 0 GOTO CHECKTOTAL2
 2140 FOR N% = 1 TO DECK2%
 2150  DECKS_VALUE%(2, N%) = TURNUPS_VALUE%(DECK4%)
 2160  DECKS_SUIT%(2, N%) = TURNUPS_SUIT%(DECK4%)
 2170  DECK4% = DECK4% - 1
 2180 NEXT N%
 2190 LABEL CHECKTOTAL2
 2200 IF DECK%1 = 0 GOTO CHECKTOTAL3
 2210 FOR N% = 1 TO DECK1%
 2220  DECKS_VALUE%(1, N%) = TURNUPS_VALUE%(DECK4%)
 2230  DECKS_SUIT%(1, N%) = TURNUPS_SUIT%(DECK4%)
 2240  DECK4% = DECK4% - 1
 2250 NEXT N%
 2260 LABEL CHECKTOTAL3
 2270 DECK4% = 0
 2280 RETURN
 2290 REM****************************************************************************
 2300 SUB DISPSCREEN(DISPMODE%)
 2310 IF DISPMODE% <> 1 GOTO DISPSCREEN1
 2320 CALL DRWBLOCK(0, 0, 639, 17, 1)
 2330 CALL DRWBLOCK(0, 18, 639, 3, 14)
 2340 CALL DRWLINE(0, 38, 639, 38, 0)
 2350 CALL BOXPUT(BUTTONS$(0), 588, 2, 0)
 2360 CALL BOXPUT(TITLE$, 20, 0, 0)
 2370 CALL BOXPUT(MENUGFX$(0), 20, 24, 0)
 2380 CALL BOXPUT(MENUGFX$(1), 73, 24, 0)
 2390 CALL BOXPUT(MENUGFX$(4), 532, 24, 0)
 2400 LABEL DISPSCREEN1
 2410 CALL DRWBLOCK(0, 39, 639, 479, 11)
 2420 CALL DRWLINE(0, 155, 639, 155, 2)
 2430 CALL DRWLINE(318, 39, 318, 155, 2)
 2440 CALL DRWLINE(321, 39, 321, 154, 6)
 2450 CALL DRWLINE(319, 155, 320, 155, 11)
 2460 CALL DRWPOINT(321, 155, 8)
 2470 INDEX% = 0
 2480 FOR X% = 326 TO 568 STEP 78
 2490  CALL DRWRECT(X%, 43, X% + 74, 151, 2)
 2500  CALL DRWLINE(X%, 43, X% + 74, 43, 6)
 2510  CALL DRWLINE(X%, 43, X%, 151, 6)
 2520  CALL DRWRECT(X% + 18, 73, X% + 56, 121, 2)
 2530  CALL DRWLINE(X% + 18, 73, X% + 56, 73, 6)
 2540  CALL DRWLINE(X% + 18, 73, X% + 18, 121, 6)
 2550  CALL BOXPUT(SUITS$(INDEX%), X% + 25, 85, 0)
 2560  INDEX% = INDEX% + 1
 2570 NEXT X%
 2580 IF VEGAS% THEN GOSUB DISPSCORE
 2590 RETURN
 2600 REM****************************************************************************
 2610 LABEL FINITO
 2620 IF STACKS_VALUE%(1) <> 13 OR STACKS_VALUE%(2) <> 13 OR STACKS_VALUE%(3) <> 13 OR STACKS_VALUE%(4) <> 13 THEN RETURN
 2630 REM PLAY "MBMST120O1L16ceg>ceg>ceg>L32cg"
 2640 REM PLAY "MBMST120O4L32cgcgcgcg"
 2650 FOR REPS% = 1 TO 400
 2660  X% = INT(RND(0) * 560)
 2670  Y% = INT(RND(0) * 330) + 40
 2680  CARDNUM% = INT(RND(0) * 52) + 1
 2690  CALL CARDPUT(X%, Y%, CARDNUM%)
 2700  CALL PAUSE(.01)
 2710 NEXT REPS%
 2720 CALL DISPSCREEN(1)
 2730 REM PLAY "MBO1L16CEGC"
 2740 X% = 30
 2750 FOR CARDNUM% = 1 TO 52
 2760  CALL CARDPUT(X%, 185, CARDNUM%)
 2770  X% = X% + 10
 2780 NEXT CARDNUM%
 2790 CALL DRWBLOCK(180, 230, 470, 265, 0)
 2800 CALL DRWRECT(185, 235, 465, 260, 4)
 2810 CALL DRWTEXT(204, 252, "C O N G R A T U L A T I O N S !", 3)
 2820 CALL PAUSE(2)
 2830 CALL DISPSCREEN(1)
 2840 GOSUB INITVALS
 2850 GOSUB SOL3DEAL
 2860 RETURN
 2870 REM****************************************************************************
 2880 LABEL INITVALS
 2890 FOR N% = 1 TO 52
 2900  DECK%(N%) = N%
 2910 NEXT N%
 2920 FOR COL% = 1 TO 7
 2930  FOR ROW% = 1 TO 18
 2940   MAINPLAY_X%(COL%, ROW%) = (COL% - 1) * 88 + 18
 2950   MAINPLAY_Y%(COL%, ROW%) = (ROW% - 1) * 18 + 158
 2960  NEXT ROW%
 2970 NEXT COL%
 2980 FOR COL% = 1 TO 7
 2990  MAINPLAY_X%(COL%, 0) = (COL% - 1) * 88 + 18
 3000  MAINPLAY_Y%(COL%, 0) = 140
 3010 NEXT COL%
 3020 RETURN
 3030 REM****************************************************************************
 3040 SUB PAUSE(SECONDS)
 3050 TIME OTIME
 3060 LABEL PAUSELOOP
 3070 TIME NTIME : IF NTIME < OTIME + SECONDS GOTO PAUSELOOP
 3080 RETURN
 3090 REM****************************************************************************
 3100 LABEL GAME
 3110 IF MOUSEY% < 43 OR MOUSEY% > 151 GOTO GAME22
 3120  IF MOUSEX% < 7 OR MOUSEX% > 81 GOTO GAME4
 3130   REM first deck
 3140   IF LB% = 0 GOTO GAME22
 3150    IF CARDSELECT% THEN GOSUB ZEROTURNUPS
 3160    IF DECK1% = 0 GOTO GAME2
 3170     CARDNUM% = (DECKS_SUIT%(1, DECK1%) - 1) * 13 + DECKS_VALUE%(1, DECK1%)
 3180     CALL CARDPUT(239, 43, CARDNUM%)
 3190     DECK4% = DECK4% + 1
 3200     TURNUPS_SUIT%(DECK4%) = DECKS_SUIT%(1, DECK1%)
 3210     TURNUPS_VALUE%(DECK4%) = DECKS_VALUE%(1, DECK1%)
 3220     DECKS_SUIT%(1, DECK1%) = 0
 3230     DECKS_VALUE%(1, DECK1%) = 0
 3240     DECK1% = DECK1% - 1
 3250     LASTDECK% = 1
 3260     IF DECK1% <> 0 GOTO GAME1
 3270      CALL DRWBLOCK(5, 43, 79, 152, 11)
 3280      IF VEGAS% <> 0 GOTO GAME1
 3290       CALL DRWRECT(24, 73, 62, 121, 2)
 3300       CALL DRWBLOCK(26, 75, 60, 119, 2)
 3310 LABEL GAME1
 3320     GOTO GAME3
 3330 LABEL GAME2
 3340     GOSUB CHECKTOTAL
 3350 LABEL GAME3
 3360    GOSUB MOUSECLEAR
 3370    GOTO GAME22
 3380 LABEL GAME4
 3390  IF MOUSEX% < 85 OR MOUSEX% > 159 GOTO GAME8
 3400   REM second deck
 3410   IF LB% = 0 GOTO GAME22
 3420    IF CARDSELECT% THEN GOSUB ZEROTURNUPS
 3430    IF DECK2% = 0 GOTO GAME6
 3440     CARDNUM% = (DECKS_SUIT%(2, DECK2%) - 1) * 13 + DECKS_VALUE%(2, DECK2%)
 3450     CALL CARDPUT(239, 43, CARDNUM%)
 3460     DECK4% = DECK4% + 1
 3470     TURNUPS_SUIT%(DECK4%) = DECKS_SUIT%(2, DECK2%)
 3480     TURNUPS_VALUE%(DECK4%) = DECKS_VALUE%(2, DECK2%)
 3490     DECKS_SUIT%(2, DECK2%) = 0
 3500     DECKS_VALUE%(2, DECK2%) = 0
 3510     DECK2% = DECK2% - 1
 3520     LASTDECK% = 2
 3530     IF DECK2% <> 0 GOTO GAME5
 3540      CALL DRWBLOCK(83, 43, 157, 152, 11)
 3550      IF VEGAS% <> 0 GOTO GAME5
 3560       CALL DRWRECT(102, 73, 140, 121, 2)
 3570       CALL DRWBLOCK(104, 75,138, 119, 2)
 3580 LABEL GAME5
 3590     GOTO GAME7
 3600 LABEL GAME6
 3610     GOSUB CHECKTOTAL
 3620 LABEL GAME7
 3630    GOSUB MOUSECLEAR
 3640    GOTO GAME22
 3650 LABEL GAME8
 3660  IF MOUSEX% < 163 OR MOUSEX% > 237 GOTO GAME12
 3670   REM third deck
 3680   IF LB% = 0 GOTO GAME22
 3690    IF CARDSELECT% THEN GOSUB ZEROTURNUPS
 3700    IF DECK3% = 0 GOTO GAME10
 3710     CARDNUM% = (DECKS_SUIT%(3, DECK3%) - 1) * 13 + DECKS_VALUE%(3, DECK3%)
 3720     CALL CARDPUT(239, 43, CARDNUM%)
 3730     DECK4% = DECK4% + 1
 3740     TURNUPS_SUIT%(DECK4%) = DECKS_SUIT%(3, DECK3%)
 3750     TURNUPS_VALUE%(DECK4%) = DECKS_VALUE%(3, DECK3%)
 3760     DECKS_SUIT%(3, DECK3%) = 0
 3770     DECKS_VALUE%(3, DECK3%) = 0
 3780     DECK3% = DECK3% - 1
 3790     LASTDECK% = 3
 3800     IF DECK3% <> 0 GOTO GAME9
 3810      CALL DRWBLOCK(161, 43, 235, 152, 11)
 3820      IF VEGAS% <> 0 GOTO GAME9
 3830       CALL DRWRECT(180, 73, 218, 121, 2)
 3840       CALL DRWBLOCK(182, 75, 216, 119, 2)
 3850 LABEL GAME9
 3860     GOTO GAME11
 3870 LABEL GAME10
 3880     GOSUB CHECKTOTAL
 3890 LABEL GAME11
 3900    GOSUB MOUSECLEAR
 3910    GOTO GAME22
 3920 LABEL GAME12
 3930  IF MOUSEX% < 241 OR MOUSEX% > 319 GOTO GAME22
 3940   REM turn-up deck
 3950   IF DECK4% = 0 GOTO GAME22
 3960    IF LB% = 0 GOTO GAME22
 3970     IF CARDSELECT% <> 0 GOTO GAME14
 3980      TSUIT% = TURNUPS_SUIT%(DECK4%)
 3990      TVALUE% = TURNUPS_VALUE%(DECK4%)
 4000      CARDNUM% = (TSUIT% - 1) * 13 + TVALUE%
 4010      IF CARDNUM% <> MONEYCARD% OR MONEY% = 0 GOTO GAME13
 4020       CALL CARDPUT(239, 43, CARDNUM%)
 4030       REM PLAY "MBT140O6L64GP32GP32GP32GP32GP32GP32GP32G"
 4040       SCORE% = SCORE% + 52 + TALLY% : GOSUB DISPSCORE
 4050       TALLY% = TALLY% + 5
 4060       MONEYCARD% = 0
 4070       GOSUB ZEROVALS
 4080       RETURN
 4090 LABEL GAME13
 4100      CALL BOXPUT(SELECTED$, 239, 43, 2)
 4110      CARDSELECT% = 2
 4120      GOTO GAME21
 4130 LABEL GAME14
 4140      IF CARDSELECT% <> 2 GOTO GAME20
 4150       TSUIT% = TURNUPS_SUIT%(DECK4%)
 4160       TVALUE% = TURNUPS_VALUE%(DECK4%)
 4170       CARDNUM% = (TSUIT% - 1) * 13 + TVALUE%
 4180       IF CARDNUM% <> MONEYCARD% OR MONEY% = 0 GOTO GAME15
 4190        CALL CARDPUT(239, 43, CARDNUM%)
 4200        REM PLAY "MBT140O6L64GP32GP32GP32GP32GP32GP32GP32G"
 4210        MONEYCARD% = 0
 4220        GOSUB ZEROVALS
 4230        RETURN
 4240 LABEL GAME15
 4250       IF STACKS_VALUE%(TSUIT%) <> TVALUE% - 1 GOTO GAME18
 4260        IF TURNUPS_VALUE%(DECK4% - 1) = 0 GOTO GAME16
 4270         CARDNUM% = (TURNUPS_SUIT%(DECK4% - 1) - 1) * 13 + TURNUPS_VALUE%(DECK4% - 1)
 4280         CALL CARDPUT(239, 43, CARDNUM%)
 4290         GOTO GAME17
 4300 LABEL GAME16
 4310         CALL DRWBLOCK(239, 43, 313, 152, 11)
 4320 LABEL GAME17
 4330        CARDNUM% = (TSUIT% - 1) * 13 + TVALUE%
 4340        CALL CARDPUT((TSUIT% - 1) * 78 + 325, 43, CARDNUM%)
 4350        SCORE% = SCORE% + 5 : TALLY% = TALLY% + 5
 4360        IF VEGAS% THEN GOSUB DISPSCORE
 4370        STACKS_VALUE%(TSUIT%) = STACKS_VALUE%(TSUIT%) + 1
 4380        TURNUPS_SUIT%(DECK4%) = 0
 4390        TURNUPS_VALUE%(DECK4%) = 0
 4400        DECK4% = DECK4% - 1
 4410        GOSUB ZEROVALS
 4420        GOTO GAME19
 4430 LABEL GAME18
 4440        CALL BOXPUT(SELECTED$, 239, 43, 2)
 4450        GOSUB ZEROVALS
 4460 LABEL GAME19
 4470       GOTO GAME21
 4480 LABEL GAME20
 4490       CALL BOXPUT(SELECTED$, FCX%, FCY%, 2)
 4500       GOSUB ZEROVALS
 4510 LABEL GAME21
 4520     GOSUB MOUSECLEAR
 4530 LABEL GAME22
 4540 IF MOUSEY% <= 159 GOTO GAME29
 4550  REM columns y
 4560  IF MOUSEX% < 18 OR MOUSEX% > 92 GOTO GAME23
 4570   REM column 1
 4580   IF LB% = 0 GOTO GAME23
 4590    COLUMN% = 1
 4600    IF CARDSELECT% = 0 THEN GOSUB SELECT1 ELSE GOSUB SELECT2
 4610    GOTO GAME29
 4620 LABEL GAME23
 4630   IF MOUSEX% < 106 OR MOUSEX% > 180 GOTO GAME24
 4640   REM column 2
 4650   IF LB% = 0 GOTO GAME24
 4660    COLUMN% = 2
 4670    IF CARDSELECT% = 0 THEN GOSUB SELECT1 ELSE GOSUB SELECT2
 4680    GOTO GAME29
 4690 LABEL GAME24
 4700  IF MOUSEX% < 194 OR MOUSEX% > 268 GOTO GAME25
 4710   REM column 3
 4720   IF LB% = 0 GOTO GAME25
 4730    COLUMN% = 3
 4740    IF CARDSELECT% = 0 THEN GOSUB SELECT1 ELSE GOSUB SELECT2
 4750    GOTO GAME29
 4760 LABEL GAME25
 4770  IF MOUSEX% < 282 OR MOUSEX% > 356 GOTO GAME26
 4780   REM column 4
 4790   IF LB% = 0 GOTO GAME26
 4800    COLUMN% = 4
 4810    IF CARDSELECT% = 0 THEN GOSUB SELECT1 ELSE GOSUB SELECT2
 4820    GOTO GAME29
 4830 LABEL GAME26
 4840  IF MOUSEX% < 370 OR MOUSEX% > 444 GOTO GAME27
 4850   REM column 5
 4860   IF LB% = 0 GOTO GAME27
 4870    COLUMN% = 5
 4880    IF CARDSELECT% = 0 THEN GOSUB SELECT1 ELSE GOSUB SELECT2
 4890    GOTO GAME29
 4900 LABEL GAME27
 4910  IF MOUSEX% < 458 OR MOUSEX% > 532 GOTO GAME28
 4920   REM column 6
 4930   IF LB% = 0 GOTO GAME28
 4940    COLUMN% = 6
 4950    IF CARDSELECT% = 0 THEN GOSUB SELECT1 ELSE GOSUB SELECT2
 4960    GOTO GAME29
 4970 LABEL GAME28
 4980  IF MOUSEX% < 546 OR MOUSEX% > 620 GOTO GAME29
 4990   REM column 7
 5000   IF LB% = 0 GOTO GAME29
 5010    COLUMN% = 7
 5020    IF CARDSELECT% = 0 THEN GOSUB SELECT1 ELSE GOSUB SELECT2
 5030 LABEL GAME29
 5040 GOSUB MOUSECLEAR
 5050 RETURN
 5060 REM************************** FIRST SELECTION SUBROUTINE **********************
 5070 LABEL SELECT1
 5080 LASTDECK% = 0
 5090 FCCOL% = COLUMN%
 5100 FOR FCROW% = 18 TO 1 STEP -1
 5110  IF MAINPLAY_VALUE%(FCCOL%, FCROW%) = 0 GOTO SELECT13
 5120   IF MAINPLAY_UPDOWN%(FCCOL%, FCROW%) <> 0 GOTO SELECT12
 5130    CN% = (MAINPLAY_SUIT%(FCCOL%, FCROW%) - 1) * 13 + MAINPLAY_VALUE%(FCCOL%, FCROW%)
 5140    CARDNUM% = CN%
 5150    FCX% = MAINPLAY_X%(FCCOL%, FCROW%)
 5160    FCY% = MAINPLAY_Y%(FCCOL%, FCROW%)
 5170    CALL CARDPUT(FCX%, FCY%, CARDNUM%)
 5180    MAINPLAY_UPDOWN%(FCCOL%, FCROW%) = 1
 5190    GOSUB ZEROVALS
 5200    GOSUB MOUSECLEAR
 5210    RETURN
 5220 LABEL SELECT12
 5230    FCSUIT% = MAINPLAY_SUIT%(FCCOL%, FCROW%)
 5240    FCVALUE% = MAINPLAY_VALUE%(FCCOL%, FCROW%)
 5250    FCX% = MAINPLAY_X%(FCCOL%, FCROW%)
 5260    FCY% = MAINPLAY_Y%(FCCOL%, FCROW%)
 5270    CALL BOXPUT(SELECTED$, FCX%, FCY%, 2)
 5280    CARDSELECT% = 1
 5290    GOSUB MOUSECLEAR
 5300    RETURN
 5310 LABEL SELECT13
 5320 NEXT FCROW%
 5330 FCROW% = 0
 5340 RETURN
 5350 REM************************ SECOND SELECTION SUBROUTINE ***********************
 5360 LABEL SELECT2
 5370 LASTDECK% = 0
 5380 SCCOL% = COLUMN%
 5390 IF CARDSELECT% <> 1 GOTO SELECT212
 5400  IF FCCOL% <> SCCOL% AND FCVALUE% <> 1 GOTO SELECT22
 5410   IF STACKS_VALUE%(FCSUIT%) <> FCVALUE% - 1 GOTO SELECT21
 5420    GOSUB LIFTCARD
 5430    CARDNUM% = (FCSUIT% - 1) * 13 + FCVALUE%
 5440    CALL CARDPUT((FCSUIT% - 1) * 78 + 325, 43, CARDNUM%)
 5450    STACKS_VALUE%(FCSUIT%) = STACKS_VALUE%(FCSUIT%) + 1
 5460    MAINPLAY_VALUE%(FCCOL%, FCROW%) = 0
 5470    MAINPLAY_VALUE%(FCCOL%, FCROW%) = 0
 5480    GOSUB ZEROVALS
 5490    SCORE% = SCORE% + 5 : TALLY% = TALLY% + 5
 5500    IF VEGAS% THEN GOSUB DISPSCORE
 5510    GOSUB MOUSECLEAR
 5520    RETURN
 5530 LABEL SELECT21
 5540    CALL BOXPUT(SELECTED$, FCX%, FCY%, 2)
 5550    GOSUB ZEROVALS
 5560    GOSUB MOUSECLEAR
 5570    RETURN
 5580 LABEL SELECT22
 5590   FOR SCROW% = 18 TO 1 STEP -1
 5600    IF MAINPLAY_VALUE%(SCCOL%, SCROW%) <> 0 GOTO SELECT23
 5610   NEXT SCROW%
 5620   SCROW% = 0
 5630 LABEL SELECT23
 5640   IF SCROW% <> 0 GOTO SELECT26
 5650    IF FCVALUE% <> 13 GOTO SELECT24
 5660     GOSUB LIFTCARD
 5670     CARDNUM% = (MAINPLAY_SUIT%(FCCOL%, FCROW%) - 1) * 13 + 13
 5680     CALL CARDPUT(MAINPLAY_X%(SCCOL%, 1), MAINPLAY_Y%(SCCOL%, 1), CARDNUM%)
 5690     MAINPLAY_SUIT%(SCCOL%, 1) = FCSUIT%
 5700     MAINPLAY_VALUE%(SCCOL%, 1) = 13
 5710     MAINPLAY_SUIT%(FCCOL%, FCROW%) = 0
 5720     MAINPLAY_VALUE%(FCCOL%, FCROW%) = 0
 5730     GOSUB ZEROVALS
 5740     GOSUB MOUSECLEAR
 5750     RETURN
 5760 LABEL SELECT24
 5770     FOR REDUCE% = FCROW% TO 0 STEP -1
 5780      IF MAINPLAY_UPDOWN%(FCCOL%, REDUCE%) <> 1 OR MAINPLAY_VALUE%(FCCOL%, REDUCE%) <> 13 GOTO SELECT25
 5790       SCROW% = 0
 5800       MATCHCARD% = REDUCE%
 5810       GOTO TRICKHANDLER
 5820 LABEL SELECT25
 5830     NEXT REDUCE%
 5840     CALL BOXPUT(SELECTED$, FCX%, FCY%, 2)
 5850     GOSUB ZEROVALS
 5860     GOSUB MOUSECLEAR
 5870     RETURN
 5880 LABEL SELECT26
 5890   FOR MATCHCARD% = FCROW% TO 0 STEP -1
 5900    IF MAINPLAY_UPDOWN%(FCCOL%, MATCHCARD%) <> 1 GOTO SELECT211
 5910     FCSUIT% = MAINPLAY_SUIT%(FCCOL%, MATCHCARD%)
 5920     FCVALUE% = MAINPLAY_VALUE%(FCCOL%, MATCHCARD%)
 5930     IF FCVALUE% + 1 <> MAINPLAY_VALUE%(SCCOL%, SCROW%) AND FCROW% <> 0 GOTO SELECT211
 5940      IF MAINPLAY_SUIT%(SCCOL%, SCROW%) MOD 2 = FCSUIT% MOD 2 GOTO SELECT211
 5950       IF MATCHCARD% >= FCROW% GOTO SELECT210
 5960 LABEL TRICKHANDLER
 5970        CLEAR TRICK_SUIT%(*), TRICK_VALUE%(*), COUNT%, SLOT%
 5980        DIM TRICK_SUIT%(18), TRICK_VALUE%(18)
 5990        FOR ROW% = FCROW% - 1 TO MATCHCARD% - 1 STEP -1
 6000         EX% = MAINPLAY_X%(FCCOL%, ROW%)
 6010         EY% = MAINPLAY_Y%(FCCOL%, ROW%)
 6020         IF MAINPLAY_UPDOWN%(FCCOL%, ROW%) <> 1 GOTO SELECT27
 6030          ERASENUM% = (MAINPLAY_SUIT%(FCCOL%, ROW%) - 1) * 13 + MAINPLAY_VALUE%(FCCOL%, ROW%)
 6040          CALL CARDPUT(EX%, EY%, ERASENUM%)
 6050          CALL DRWBLOCK(EX%, EY% + 109, EX% + 74, EY% + 127, 11)
 6060          GOTO SELECT29
 6070 LABEL SELECT27
 6080          IF MAINPLAY_VALUE%(FCCOL%, ROW%) <> 0 GOTO SELECT28
 6090           CALL DRWBLOCK((FCCOL% - 1) * 88 + 18, 158, (FCCOL% - 1) * 88 + 92, 284, 11)
 6100           GOTO SELECT29
 6110 LABEL SELECT28
 6120           CALL GTCOLOR(COLR%, EX% + 1, EY% - 1)
 6130           CALL BOXPUT(BACKERASE$, EX%, EY%, 0)
 6140           IF COLR% = 15 THEN CALL BOXPUT(TPOFF$, EX%, EY%, 0)
 6150 LABEL SELECT29
 6160         COUNT% = COUNT% + 1
 6170         TRICK_SUIT%(COUNT%) = MAINPLAY_SUIT%(FCCOL%, ROW% + 1)
 6180         TRICK_VALUE%(COUNT%) = MAINPLAY_VALUE%(FCCOL%, ROW% + 1)
 6190         MAINPLAY_SUIT%(FCCOL%, ROW% + 1) = 0
 6200         MAINPLAY_VALUE%(FCCOL%, ROW% + 1) = 0
 6210        NEXT ROW%
 6220        X% = MAINPLAY_X%(SCCOL%, SCROW%)
 6230        Y% = MAINPLAY_Y%(SCCOL%, SCROW%)
 6240        FOR CARDS% = FCROW% - MATCHCARD% + 1 TO 1 STEP -1
 6250         CARDNUM% = (TRICK_SUIT%(CARDS%) - 1) * 13 + TRICK_VALUE%(CARDS%)
 6260         SLOT% = SLOT% + 1
 6270         MAINPLAY_SUIT%(SCCOL%, SCROW% + SLOT%) = TRICK_SUIT%(CARDS%)
 6280         MAINPLAY_VALUE%(SCCOL%, SCROW% + SLOT%) = TRICK_VALUE%(CARDS%)
 6290         MAINPLAY_UPDOWN%(SCCOL%, SCROW% + SLOT%) = 1
 6300         Y% = Y% + 18
 6310         CALL CARDPUT(X%, Y%, CARDNUM%)
 6320        NEXT CARDS%
 6330        GOSUB MOUSECLEAR
 6340        GOSUB ZEROVALS
 6350        RETURN
 6360 LABEL SELECT210
 6370        GOSUB LIFTCARD
 6380        CARDNUM% = (FCSUIT% - 1) * 13 + FCVALUE%
 6390        NCX% = MAINPLAY_X%(SCCOL%, SCROW%)
 6400        NCY% = MAINPLAY_Y%(SCCOL%, SCROW% + 1)
 6410        CALL CARDPUT(NCX%, NCY%, CARDNUM%)
 6420        GOSUB MOUSECLEAR
 6430        MAINPLAY_SUIT%(SCCOL%, SCROW% + 1) = FCSUIT%
 6440        MAINPLAY_VALUE%(SCCOL%, SCROW% + 1) = FCVALUE%
 6450        MAINPLAY_UPDOWN%(SCCOL%, SCROW% + 1) = 1
 6460        MAINPLAY_SUIT%(FCCOL%, FCROW%) = 0
 6470        MAINPLAY_VALUE%(FCCOL%, FCROW%) = 0
 6480        GOSUB ZEROVALS
 6490        RETURN
 6500 LABEL SELECT211
 6510   NEXT MATCHCARD%
 6520   CALL BOXPUT(SELECTED$, FCX%, FCY%, 2)
 6530   GOSUB ZEROVALS
 6540   GOSUB MOUSECLEAR
 6550   RETURN
 6560 LABEL SELECT212
 6570  REM CardSELECT = 2
 6580  FOR SCROW% = 18 TO 1 STEP -1
 6590   IF MAINPLAY_VALUE%(SCCOL%, SCROW%) <> 0 GOTO SELECT213
 6600  NEXT SCROW%
 6610  SCROW% = 0
 6620 LABEL SELECT213
 6630  IF SCROW% <> 0 OR TURNUPS_VALUE%(DECK4%) <> 13 GOTO SELECT216
 6640   IF DECK4% <= 1 GOTO SELECT214
 6650    CARDNUM% = (TURNUPS_SUIT%(DECK4% - 1) - 1) * 13 + TURNUPS_VALUE%(DECK4% - 1)
 6660    CALL CARDPUT(239, 43, CARDNUM%)
 6670    GOTO SELECT215
 6680 LABEL SELECT214
 6690    CALL DRWBLOCK(239, 43, 313, 153, 11)
 6700 LABEL SELECT215
 6710   CARDNUM% = (TURNUPS_SUIT%(DECK4%) - 1) * 13 + 13
 6720   CALL CARDPUT(MAINPLAY_X%(SCCOL%, 1), 158, CARDNUM%)
 6730   MAINPLAY_SUIT%(SCCOL%, 1) = TURNUPS_SUIT%(DECK4%)
 6740   MAINPLAY_VALUE%(SCCOL%, 1) = TURNUPS_VALUE%(DECK4%)
 6750   TURNUPS_SUIT%(DECK4%) = 0
 6760   TURNUPS_VALUE%(DECK4%) = 0
 6770   DECK4% = DECK4% - 1
 6780   GOSUB ZEROVALS
 6790   GOSUB MOUSECLEAR
 6800   RETURN
 6810 LABEL SELECT216
 6820  IF TURNUPS_SUIT%(DECK4%) MOD 2 = MAINPLAY_SUIT%(SCCOL%, SCROW%) MOD 2 GOTO SELECT221
 6830   IF TURNUPS_VALUE%(DECK4%) + 1 <> MAINPLAY_VALUE%(SCCOL%, SCROW%) GOTO SELECT220
 6840    CALL BOXPUT(SELECTED$, 239, 43, 2)
 6850    CARDNUMTOP% = (TURNUPS_SUIT%(DECK4%) - 1) * 13 + TURNUPS_VALUE%(DECK4%)
 6860    SCSUIT% = TURNUPS_SUIT%(DECK4%)
 6870    SCVALUE% = TURNUPS_VALUE%(DECK4%)
 6880    TURNUPS_SUIT%(DECK4%) = 0
 6890    TURNUPS_VALUE%(DECK4%) = 0
 6900    IF DECK4% = 0 GOTO SELECT219
 6910     DECK4% = DECK4% - 1
 6920     IF DECK4% <> 0 GOTO SELECT217
 6930      CALL DRWBLOCK(239, 43, 313, 152, 11)
 6940      GOTO SELECT218
 6950 LABEL SELECT217
 6960      CARDNUM% = (TURNUPS_SUIT%(DECK4%) - 1) * 13 + TURNUPS_VALUE%(DECK4%)
 6970      CALL CARDPUT(239, 43, CARDNUM%)
 6980 LABEL SELECT218
 6990     CALL CARDPUT(MAINPLAY_X%(SCCOL%, SCROW%), MAINPLAY_Y%(SCCOL%, SCROW% + 1), CARDNUMTOP%)
 7000     MAINPLAY_SUIT%(SCCOL%, SCROW% + 1) = SCSUIT%
 7010     MAINPLAY_VALUE%(SCCOL%, SCROW% + 1) = SCVALUE%
 7020     MAINPLAY_UPDOWN%(SCCOL%, SCROW% + 1) = 1
 7030     GOSUB ZEROVALS
 7040     GOSUB MOUSECLEAR
 7050     RETURN
 7060 LABEL SELECT219
 7070     CALL DRWBLOCK(239, 43, 315, 152, 11)
 7080     GOSUB ZEROVALS
 7090     GOSUB MOUSECLEAR
 7100     RETURN
 7110 LABEL SELECT220
 7120    CALL BOXPUT(SELECTED$, 239, 43, 2)
 7130    GOSUB ZEROVALS
 7140    GOSUB MOUSECLEAR
 7150    RETURN
 7160 LABEL SELECT221
 7170   CALL BOXPUT(SELECTED$, 239, 43, 2)
 7180   GOSUB ZEROVALS
 7190   GOSUB MOUSECLEAR
 7200   RETURN
 7210 RETURN
 7220 REM****************************************************************************
 7230 LABEL ZEROVALS
 7240 FCCOL% = 0: FCROW% = 0: FCX% = 0: FCY% = 0: FCSUIT% = 0: FCVALUE% = 0: COLUMN% = 0: CARDSELECT% = 0
 7250 RETURN
 7260 REM****************************************************************************
 7270 LABEL LIFTCARD
 7280 IF FCROW% <> 1 GOTO LIFTCARD1
 7290  CALL DRWBLOCK((FCCOL% - 1) * 88 + 18, 158, (FCCOL% - 1) * 88 + 92, 266, 11)
 7300  GOTO LIFTCARD3
 7310 LABEL LIFTCARD1
 7320  IF MAINPLAY_UPDOWN%(FCCOL%, FCROW% - 1) <> 1 GOTO LIFTCARD2
 7330   CARDNUM% = (MAINPLAY_SUIT%(FCCOL%, FCROW% - 1) - 1) * 13 + MAINPLAY_VALUE%(FCCOL%, FCROW% - 1)
 7340   CALL CARDPUT(FCX%, FCY% - 18, CARDNUM%)
 7350   CALL DRWBLOCK(FCX%, FCY% + 91, FCX% + 74, FCY% + 109, 11)
 7360   GOTO LIFTCARD3
 7370 LABEL LIFTCARD2
 7380   CALL GTCOLOR(COLR%, FCX% + 1, FCY% - 19)
 7390   CALL BOXPUT(BACKERASE$, FCX%, FCY% - 18, 0)
 7400   IF COLR% = 15 THEN CALL BOXPUT(TPOFF$, FCX%, FCY% - 18, 0)
 7410 LABEL LIFTCARD3
 7420 RETURN
 7430 REM****************************************************************************
 7440 LABEL ZEROTURNUPS
 7450 IF CARDSELECT% = 1 THEN CALL BOXPUT(SELECTED$, FCX%, FCY%, 2)
 7460 GOSUB ZEROVALS
 7470 RETURN
 7480 REM****************************************************************************
 7490 SUB CARDPUT(X%, Y%, CARDNUM%)
 7500 IF MONEY% = 0 GOTO CARDPUT1
 7510  IF HOLDNUM% = CARDNUM% THEN DEALT% = 1
 7520  IF CARDNUM% = MONEYCARD% AND DEALT% = 0 THEN HOLDNUM% = CARDNUM% : CARDNUM% = 55
 7530 LABEL CARDPUT1
 7540 CALL GTCOLOR(COLR%, X% + 1, Y% - 1)
 7550 CALL BOXPUT(CARD$(CARDNUM%), X%, Y%, 0)
 7560 IF COLR% = 15 THEN CALL BOXPUT(TPOFF$, X%, Y%, 0)
 7570 RETURN
 7580 REM****************************************************************************
 7590 LABEL DISPSCORE
 7600 IF SCORE% < 0 THEN PSCORE% = ABS(SCORE%) : MINUS% = 1 ELSE PSCORE% = SCORE% : MINUS% = 0
 7610 SCOR$ = "$" + LTRIM$(RTRIM$(STR$(PSCORE%)))
 7620 CALL DRWBLOCK(564, 23, 631, 34, 14)
 7630 X% = 572
 7640 IF MINUS% THEN CALL DRWLINE(566, 29, 571, 29, 4)
 7650 FOR N% = 1 TO LEN(SCOR$)
 7660  CHAR$ = MID$(SCOR$, N%, 1)
 7670  IF CHAR$ = "$" THEN INDEX% = 10 ELSE INDEX% = VAL(CHAR$)
 7680  IF MINUS% THEN INDEX% = INDEX% + 11
 7690  CALL BOXPUT(NUMBERS$(INDEX%), X%, 23, 0)
 7700  X% = X% + 7
 7710 NEXT N%
 7720 IF MINUS% THEN INDEX% = 11: COLR% = 4 ELSE INDEX% = 0: COLR% = 2
 7730 CALL DRWRECT(X% + 1, 31, X% + 2, 32, COLR%)
 7740 CALL BOXPUT(NUMBERS$(INDEX%), X% + 5, 23, 0)
 7750 CALL BOXPUT(NUMBERS$(INDEX%), X% + 12, 23, 0)
 7760 RETURN
 7770 REM****************************************************************************
 7780 LABEL SOL3DEAL
 7790 REM Randomize
 7800 TIME X
 7810 X = RND(-ABS(X))
 7820 CALL DISPSCREEN(2)
 7830 FOR N%=1 TO 4 : STACKS_SUIT%(N%) = 0 : STACKS_VALUE%(N%) = 0 : NEXT N%
 7840 HOLDNUM% = 0: DEALT% = 0
 7850 FOR X% = 5 TO 161 STEP 78
 7860  CALL BOXPUT(CARDBACK$, X%, 43, 0)
 7870 NEXT X%
 7880 FOR COL% = 1 TO 7
 7890  FOR ROW% = 1 TO 18
 7900   MAINPLAY_SUIT%(COL%, ROW%) = 0
 7910   MAINPLAY_VALUE%(COL%, ROW%) = 0
 7920   MAINPLAY_UPDOWN%(COL%, ROW%) = 0
 7930  NEXT ROW%
 7940 NEXT COL%
 7950 REM Shuffle cards
 7960 FOR N% = 52 TO 2 STEP -1
 7970  CARD% = INT(RND(0) * N%) + 1
 7980  SWAP DECK%(N%), DECK%(CARD%)
 7990 NEXT N%
 8000 MONEYNUM% = INT(RND(0) * 24) + 29
 8010 MONEYCARD% = DECK%(MONEYNUM%)
 8020 PASTEBOARD% = 0
 8030 FOR ROW% = 1 TO 7
 8040  FOR COL% = ROW% TO 7
 8050   PASTEBOARD% = PASTEBOARD% + 1
 8060   DECKVALUE% = DECK%(PASTEBOARD%)
 8070   IF DECKVALUE% >= 1 AND DECKVALUE% <= 13 THEN MAINPLAY_SUIT%(COL%, ROW%) = 1 : MAINPLAY_VALUE%(COL%, ROW%) = DECKVALUE%
 8080   IF DECKVALUE% >= 14 AND DECKVALUE% <= 26 THEN MAINPLAY_SUIT%(COL%, ROW%) = 2 : MAINPLAY_VALUE%(COL%, ROW%) = DECKVALUE% - 13
 8090   IF DECKVALUE% >= 27 AND DECKVALUE% <= 39 THEN MAINPLAY_SUIT%(COL%, ROW%) = 3 : MAINPLAY_VALUE%(COL%, ROW%) = DECKVALUE% - 26
 8100   IF DECKVALUE% >= 40 AND DECKVALUE% <= 52 THEN MAINPLAY_SUIT%(COL%, ROW%) = 4 : MAINPLAY_VALUE%(COL%, ROW%) = DECKVALUE% - 39
 8110   MDVALUE% = DECK%(PASTEBOARD%) MOD 13
 8120   IF MDVALUE% = 0 THEN MDVALUE% = 13
 8130   MAINPLAY_VALUE%(COL%, ROW%) = MDVALUE%
 8140   X% = MAINPLAY_X%(COL%, ROW%)
 8150   Y% = MAINPLAY_Y%(COL%, ROW%)
 8160   IF ROW% = COL% THEN MAINPLAY_UPDOWN%(COL%, ROW%) = 1 : CALL CARDPUT(X%, Y%, DECKVALUE%) : GOTO SOL3DEAL1 
 8170    MAINPLAY_UPDOWN%(ROW%, COL%) = 0
 8180    CALL GTCOLOR(COLR%, X% + 1, Y% - 1)
 8190    CALL BOXPUT(CARDBACK$, X%, Y%, 0)
 8200    IF COLR% = 15 THEN CALL BOXPUT(TPOFF$, X%, Y%, 0)
 8210 LABEL SOL3DEAL1
 8220  NEXT COL%
 8230 NEXT ROW%
 8240 FOR COL% = 1 TO 3
 8250  FOR NUM% = 1 TO 8
 8260   PASTEBOARD% = PASTEBOARD% + 1
 8270   DECKVALUE% = DECK%(PASTEBOARD%)
 8280   IF DECKVALUE% >= 1 AND DECKVALUE% <= 13 THEN DECKS_SUIT%(COL%, NUM%) = 1 : DECKS_VALUE%(COL%, NUM%) = DECKVALUE%
 8290   IF DECKVALUE% >= 14 AND DECKVALUE% <= 26 THEN DECKS_SUIT%(COL%, NUM%) = 2 : DECKS_VALUE%(COL%, NUM%) = DECKVALUE% - 13
 8300   IF DECKVALUE% >= 27 AND DECKVALUE% <= 39 THEN DECKS_SUIT%(COL%, NUM%) = 3 : DECKS_VALUE%(COL%, NUM%) = DECKVALUE% - 26
 8310   IF DECKVALUE% >= 40 AND DECKVALUE% <= 52 THEN DECKS_SUIT%(COL%, NUM%) = 4 : DECKS_VALUE%(COL%, NUM%) = DECKVALUE% - 39
 8320  NEXT NUM%
 8330 NEXT COL%
 8340 DECK1% = 8: DECK2% = 8: DECK3% = 8: DECK4% = 0: CARDSELECT% = 0
 8350 FCCOL% = 0: FCROW% = 0: FCX% = 0: FCY% = 0: FCSUIT% = 0: FCVALUE% = 0
 8360 SCORE% = SCORE% - 52: TALLY% = -52
 8370 IF VEGAS% THEN GOSUB DISPSCORE ELSE SCORE% = 0
 8380 RETURN
 8390 REM****************************************************************************
 8400 SUB SOL3HELP(ITEM%)
 8410 CALL BOXGET(GTBOX$, 194, 80, 446, 203)
 8420 IF ITEM% <> 1 GOTO SOL3HELP1
 8430  REM Introduction
 8440  FIRSTPAGE% = 1: LASTPAGE% = 5
 8450  GOTO SOL3HELP4
 8460 LABEL SOL3HELP1
 8470 IF ITEM% <> 2 GOTO SOL3HELP2
 8480  REM Basic Solitaire
 8490  FIRSTPAGE% = 6: LASTPAGE% = 11
 8500  GOTO SOL3HELP4
 8510 LABEL SOL3HELP2
 8520 IF ITEM% <> 3 GOTO SOL3HELP3
 8530  REM Game Options
 8540  FIRSTPAGE% = 12: LASTPAGE% = 15
 8550  GOTO SOL3HELP4
 8560 LABEL SOL3HELP3
 8570 IF ITEM% <> 4 GOTO SOL3HELP4
 8580  REM About Solitaire 3
 8590  BLOAD "sol3hp16.bmp" OTHERBOX$
 8600  CALL BOXPUT(OTHERBOX$, 194, 80, 0)
 8610 LABEL SOL3HELP4
 8620 IF ITEM% <> 4 THEN CURRENTPAGE% = FIRSTPAGE% : GOSUB DISPHELP
 8630 LABEL SOL3HELP5
 8640  GOSUB MOUSESTATUS
 8650  IF MOUSEY% <= 85 OR MOUSEY% >= 100 GOTO SELECT8
 8660   IF MOUSEX% < 389 OR MOUSEX% > 403 GOTO SELECT6
 8670    REM Left arrow button
 8680    IF LB% AND CURRENTPAGE% > FIRSTPAGE% THEN CURRENTPAGE% = CURRENTPAGE% - 1 : GOSUB DISPHELP
 8690    GOTO SELECT8
 8700 LABEL SELECT6
 8710   IF MOUSEX% < 405 OR MOUSEX% > 419 GOTO SELECT7
 8720    REM Right arrow button
 8730    IF LB% AND CURRENTPAGE% < LASTPAGE% THEN CURRENTPAGE% = CURRENTPAGE% + 1 : GOSUB DISPHELP
 8740    GOTO SELECT8
 8750 LABEL SELECT7
 8760   IF MOUSEX% < 423 OR MOUSEX% > 437 GOTO SELECT8
 8770    REM Close button
 8780    IF LB% = 0 GOTO SELECT8
 8790     GOSUB HELPCLOSE
 8800     RETURN
 8810 LABEL SELECT8
 8820 GOSUB MOUSECLEAR
 8830 GOSUB MOUSEPAUSE
 8840 GOTO SOL3HELP5
 8850 REM****************************************************************************
 8860 LABEL HELPCLOSE
 8870 CALL BOXGET(BUTTONS$(3), 423, 86, 437, 99)
 8880 CALL BOXPUT(BUTTONS$(2), 423, 86, 0)
 8890 CALL PAUSE(.1)
 8900 CALL BOXPUT(BUTTONS$(3), 423, 86, 0)
 8910 CALL BOXPUT(GTBOX$, 194, 80, 0)
 8920 GOSUB MOUSECLEAR
 8930 RETURN
 8940 REM****************************************************************************
 8950 LABEL DOARROWS
 8960 IF CURRENTPAGE% > FIRSTPAGE% GOTO DOARROWS1
 8970  CALL DRWFILL(396, 92, 14, 15)
 8980  GOTO DOARROWS2
 8990 LABEL DOARROWS1
 9000  CALL DRWFILL(396, 92, 14, 1)
 9010 LABEL DOARROWS2
 9020 IF CURRENTPAGE% < LASTPAGE% GOTO DOARROWS3
 9030  CALL DRWFILL(411, 92, 14, 15)
 9040  GOTO DOARROWS4
 9050 LABEL DOARROWS3
 9060  CALL DRWFILL(411, 92, 14, 1)
 9070 LABEL DOARROWS4
 9080 RETURN
 9090 REM****************************************************************************
 9100 LABEL DISPHELP
 9110 FILENAME$ = "Sol3HP" + LTRIM$(RTRIM$(STR$(CURRENTPAGE%))) + ".BMP"
 9120 BLOAD FILENAME$ OTHERBOX$
 9130 CALL BOXPUT(OTHERBOX$, 194, 80, 0)
 9140 GOSUB DOARROWS
 9150 RETURN
 9160 REM****************************************************************************
 9170 SUB SOL3MENU(INOUT%)
 9180 IF INOUT% = 0 THEN GOSUB MENUPUT : RETURN
 9190 IF MENU% <> 3 GOTO SOL3MENU27
 9200  REM**************************** MENU OPEN SECTION ****************************
 9210  REM Game menu open
 9220  IF MOUSEX% < 10 OR MOUSEX% > 110 THEN GOSUB MENUCLOSE : RETURN
 9230  IF MOUSEY% >= 20 GOTO SOL3MENU1
 9240   GOSUB MENUCLOSE
 9250   GOTO SOL3MENU26
 9260 LABEL SOL3MENU1
 9270  IF MOUSEY% > 37 GOTO SOL3MENU2
 9280   IF MOUSEX% < 12 OR MOUSEX% > 52 THEN GOSUB MENUCLOSE
 9290   GOTO SOL3MENU26
 9300 LABEL SOL3MENU2
 9310  IF MOUSEY% < 42 OR MOUSEY% > 56 GOTO SOL3MENU4
 9320   IF ITEM% = 1 GOTO SOL3MENU3
 9330    IF ITEM% THEN GOSUB ITEMPUT
 9340    IX% = 16: IY% = 42
 9350    GOSUB ITEMGET
 9360    ITEM% = 1
 9370 LABEL SOL3MENU3
 9380   IF LB% = 0 GOTO SOL3MENU26
 9390    GOSUB MENUCLOSE
 9400    GOSUB SOL3DEAL
 9410    GOSUB MOUSECLEAR
 9420    GOTO SOL3MENU26
 9430 LABEL SOL3MENU4
 9440  IF MOUSEY% < 57 OR MOUSEY% > 71 GOTO SOL3MENU6
 9450   IF ITEM% = 2 GOTO SOL3MENU5
 9460   IF ITEM% THEN GOSUB ITEMPUT
 9470   IX% = 16: IY% = 57
 9480   GOSUB ITEMGET
 9490   ITEM% = 2
 9500 LABEL SOL3MENU5
 9510   IF LB% = 0 GOTO SOL3MENU26
 9520    GOSUB MENUCLOSE
 9530    GOSUB SOL3UNDO
 9540    GOSUB MOUSECLEAR
 9550    GOTO SOL3MENU26
 9560 LABEL SOL3MENU6
 9570  IF MOUSEY% < 72 OR MOUSEY% > 86 GOTO SOL3MENU23
 9580   IF ITEM% = 3 GOTO SOL3MENU7
 9590    IF ITEM% THEN GOSUB ITEMPUT
 9600    IX% = 16: IY% = 72
 9610    GOSUB ITEMGET
 9620    ITEM% = 3
 9630 LABEL SOL3MENU7
 9640   IF LB% = 0 GOTO SOL3MENU26
 9650   GOSUB MENUCLOSE
 9660   BLOAD "sol3hp17.bmp" OTHERBOX$
 9670   CALL BOXGET(GTBOX$, 194, 80, 446, 203)
 9680   CALL BOXPUT(OTHERBOX$, 194, 80, 0)
 9690   IF VEGAS% = 1 THEN CALL BOXPUT(CHEK$, 246, 137, 0)
 9700   IF VEGAS% = 0 THEN CALL BOXPUT(CHEK$, 246, 155, 0)
 9710   IF MONEY% = 1 THEN CALL BOXPUT(CHEK$, 246, 173, 0)
 9720 LABEL SOL3MENU8
 9730    GOSUB MOUSESTATUS
 9740    IF MOUSEY% < 86 OR MOUSEY% > 99 GOTO SOL3MENU9
 9750     REM close options menu
 9760     IF MOUSEX% <= 422 OR MOUSEX% >= 438 OR LB% = 0 GOTO SOL3MENU20
 9770      CALL BOXGET(BUTTONS$(3), 423, 86, 437, 99)
 9780      CALL BOXPUT(BUTTONS$(2), 423, 86, 0)
 9790      CALL PAUSE(.1)
 9800      CALL BOXPUT(BUTTONS$(3), 423, 86, 0)
 9810      GOTO SOL3MENU21
 9820 LABEL SOL3MENU9
 9830    IF MOUSEY% < 136 OR MOUSEY% > 145 GOTO SOL3MENU13
 9840     REM select Vegas type scoring
 9850     IF MOUSEX% <= 243 OR MOUSEX% >= 260 OR LB% = 0 GOTO SOL3MENU12
 9860      IF VEGAS% <> 1 GOTO SOL3MENU10
 9870       VEGAS% = 0: SCORE% = 0
 9880       CALL BOXPUT(CHEK$, 246, 155, 0)
 9890       CALL DRWBLOCK(245, 137, 258, 144, 15)
 9900       CALL DRWBLOCK(563, 18, 639, 37, 14)
 9910       IF MONEY% THEN CALL DRWBLOCK(245, 173, 258, 180, 15) : MONEY% = 0
 9920      GOTO SOL3MENU11
 9930 LABEL SOL3MENU10
 9940        CALL BOXPUT(CHEK$, 246, 137, 0)
 9950        CALL DRWBLOCK(245, 155, 258, 162, 15)
 9960        VEGAS% = 1: SCORE% = TALLY%
 9970 LABEL SOL3MENU11
 9980      NWDEAL% = 1
 9990 LABEL SOL3MENU12
10000     GOTO SOL3MENU20
10010 LABEL SOL3MENU13
10020    IF MOUSEY% < 154 OR MOUSEY% > 163 GOTO SOL3MENU17
10030     REM select no scoring (continuous play)
10040     IF MOUSEX% <= 243 OR MOUSEX% >= 260 OR LB% = 0 GOTO SOL3MENU16
10050      IF VEGAS% <> 1 GOTO SOL3MENU14
10060       CALL DRWBLOCK(563, 18, 639, 37, 14)
10070       CALL DRWBLOCK(246, 137, 258, 144, 15)
10080       VEGAS% = 0 : SCORE% = 0
10090       CALL BOXPUT(CHEK$, 246, 155, 0)
10100       IF MONEY% = 1 THEN CALL DRWBLOCK(246, 173, 258, 180, 15) : MONEY% = 0
10110       GOTO SOL3MENU15
10120 LABEL SOL3MENU14
10130       CALL BOXPUT(CHEK$, 246, 137, 0)
10140       CALL DRWBLOCK(245, 155, 258, 162, 15)
10150       VEGAS% = 1: SCORE% = TALLY%
10160 LABEL SOL3MENU15
10170       GOSUB MOUSECLEAR
10180       NWDEAL% = 1
10190 LABEL SOL3MENU16
10200      GOTO SOL3MENU20
10210 LABEL SOL3MENU17
10220    IF MOUSEY% < 172 OR MOUSEY% > 181 GOTO SOL3MENU20
10230     REM money card
10240     IF MOUSEX% <= 243 OR MOUSEX% >= 260 OR LB% = 0 GOTO SOL3MENU20
10250      IF MONEY% <> 1 GOTO SOL3MENU18
10260       CALL DRWBLOCK(245, 173, 258, 180, 15)
10270       MONEY% = 0
10280       GOTO SOL3MENU19
10290 LABEL SOL3MENU18
10300       CALL BOXPUT(CHEK$, 246, 173, 0)
10310       MONEY% = 1
10320       IF VEGAS% <> 0 GOTO SOL3MENU19
10330        CALL BOXPUT(CHEK$, 246, 137, 0)
10340        CALL DRWBLOCK(245, 155, 258, 162, 15)
10350        VEGAS% = 1: SCORE% = TALLY%
10360 LABEL SOL3MENU19
10370      NWDEAL% = 1
10380 LABEL SOL3MENU20
10390    GOSUB MOUSEPAUSE
10400    GOTO SOL3MENU8
10410 LABEL SOL3MENU21
10420   OPEN NEW "sol3opts.dat" AS 1
10430   PRINT #1, VEGAS%;",";MONEY%
10440   CLOSE 1
10450   CALL BOXPUT(GTBOX$, 194, 80, 0)
10460   IF NWDEAL% = 0 GOTO SOL3MENU22
10470    SCORE% = 0
10480    GOSUB SOL3DEAL
10490    IF VEGAS% THEN GOSUB DISPSCORE
10500    GOSUB MOUSECLEAR
10510    RETURN
10520 LABEL SOL3MENU22
10530   GOSUB MOUSECLEAR
10540   GOTO SOL3MENU26
10550 LABEL SOL3MENU23
10560  IF MOUSEY% < 92 OR MOUSEY% > 106 GOTO SOL3MENU25
10570   IF ITEM% = 4 GOTO SOL3MENU24
10580    IF ITEM% THEN GOSUB ITEMPUT
10590    IX% = 16: IY% = 92
10600    GOSUB ITEMGET
10610    ITEM% = 4
10620 LABEL SOL3MENU24
10630   IF LB% = 0 GOTO SOL3MENU26
10640    GOSUB MENUCLOSE
10650    CLEAR
10660    END
10670 LABEL SOL3MENU25
10680  IF MOUSEY% <= 106 GOTO SOL3MENU26
10690   GOSUB MENUCLOSE
10700 LABEL SOL3MENU26
10710   RETURN
10720 LABEL SOL3MENU27
10730 IF MENU% <> 4 GOTO SOL3MENU39
10740  REM Help menu open
10750  IF MOUSEX% < 63 OR MOUSEX% > 163 THEN GOSUB MENUCLOSE : RETURN
10760  IF MOUSEY% >= 20 GOTO SOL3MENU28
10770   GOSUB MENUCLOSE
10780   GOTO SOL3MENU38
10790 LABEL SOL3MENU28
10800  IF MOUSEY% > 37 GOTO SOL3MENU29
10810   IF MOUSEX% < 63 OR MOUSEX% > 103 THEN GOSUB MENUCLOSE
10820   GOTO SOL3MENU38
10830 LABEL SOL3MENU29
10840  IF MOUSEY% < 42 OR MOUSEY% > 56 GOTO SOL3MENU31
10850   IF ITEM% = 1 GOTO SOL3MENU30
10860    IF ITEM% THEN GOSUB ITEMPUT
10870    IX% = 66: IY% = 42
10880    GOSUB ITEMGET
10890    ITEM% = 1
10900 LABEL SOL3MENU30
10910   IF LB% = 0 GOTO SOL3MENU38
10920    GOSUB MENUCLOSE
10930    CALL SOL3HELP(1)
10940    GOSUB MOUSECLEAR
10950    GOTO SOL3MENU38
10960 LABEL SOL3MENU31
10970  IF MOUSEY% < 57 OR MOUSEY% > 71 GOTO SOL3MENU33
10980   IF ITEM% = 2 GOTO SOL3MENU32
10990    IF ITEM% THEN GOSUB ITEMPUT
11000    IX% = 66: IY% = 57
11010    GOSUB ITEMGET
11020    ITEM% = 2
11030 LABEL SOL3MENU32
11040   IF LB% = 0 GOTO SOL3MENU38
11050    GOSUB MENUCLOSE
11060    CALL SOL3HELP(2)
11070    GOSUB MOUSECLEAR
11080    GOTO SOL3MENU38
11090 LABEL SOL3MENU33
11100  IF MOUSEY% < 72 OR MOUSEY% > 86 GOTO SOL3MENU35
11110   IF ITEM% = 3 GOTO SOL3MENU34
11120    IF ITEM% THEN GOSUB ITEMPUT
11130    IX% = 66: IY% = 72
11140    GOSUB ITEMGET
11150    ITEM% = 3
11160 LABEL SOL3MENU34
11170   IF LB% = 0 GOTO SOL3MENU38
11180    GOSUB MENUCLOSE
11190    CALL SOL3HELP(3)
11200    GOSUB MOUSECLEAR
11210    GOTO SOL3MENU38
11220 LABEL SOL3MENU35
11230  IF MOUSEY% < 92 OR MOUSEY% > 106 GOTO SOL3MENU37
11240   IF ITEM% = 4 GOTO SOL3MENU36
11250    IF ITEM% THEN GOSUB ITEMPUT
11260    IX% = 66: IY% = 92
11270    GOSUB ITEMGET
11280    ITEM% = 4
11290 LABEL SOL3MENU36
11300   IF LB% = 0 GOTO SOL3MENU38
11310    GOSUB MENUCLOSE
11320    CALL SOL3HELP(4)
11330    GOSUB MOUSECLEAR
11340    GOTO SOL3MENU38
11350 LABEL SOL3MENU37
11360  IF MOUSEY% <= 106 GOTO SOL3MENU38
11370   GOSUB MENUCLOSE
11380 LABEL SOL3MENU38
11390 RETURN
11400 LABEL SOL3MENU39
11410 REM*************************** MENU CLOSED SECTION ****************************
11420 IF MOUSEX% >= 12 GOTO SOL3MENU40
11430  IF MENU% THEN GOSUB MENUPUT
11440  GOTO SOL3MENU46
11450 LABEL SOL3MENU40
11460 IF MOUSEX% > 52 GOTO SOL3MENU43
11470  IF MENU% = 1 GOTO SOL3MENU41 : REM -------------------- Game selected
11480   IF MENU% THEN GOSUB MENUPUT
11490   MENUX% = 12
11500   GOSUB MENUGET
11510   CALL DRWRECT(12, 20, 52, 36, 15)
11520   CALL DRWLINE(12, 36, 52, 36, 0)
11530   CALL DRWLINE(52, 20, 52, 36, 0)
11540   CALL BOXPUT(MENUGFX$(2), 20, 24, 0)
11550   MENU% = 1
11560 LABEL SOL3MENU41
11570  IF MENU% <> 1 GOTO SOL3MENU42 : REM -------------- Game opens
11580   CALL DRWBLOCK(12, 20, 52, 36, 14)
11590   CALL DRWRECT(12, 20, 52, 36, 15)
11600   CALL DRWLINE(12, 20, 12, 36, 0)
11610   CALL DRWLINE(12, 20, 52, 20, 0)
11620   CALL BOXPUT(MENUGFX$(0), 21, 24, 0)
11630   CALL BOXGET(GTBOX$, 12, 37, 112, 110)
11640   MENUXX% = 12
11650   BLOAD "sol3men2.bmp" OTHERBOX$
11660   CALL BOXPUT(OTHERBOX$, 12, 37, 0)
11670   MENU% = 3
11680 LABEL SOL3MENU42
11690  GOTO SOL3MENU46
11700 LABEL SOL3MENU43
11710 IF MOUSEX% < 53 OR MOUSEX% > 62 GOTO SOL3MENU44
11720  IF MENU% THEN GOSUB MENUPUT
11730  GOTO SOL3MENU46
11740 LABEL SOL3MENU44
11750 IF MOUSEX% < 63 OR MOUSEX% > 103 GOTO SOL3MENU46
11760  IF MENU% = 2 GOTO SOL3MENU45 : REM ------------------ Help selected
11770   IF MENU% THEN GOSUB MENUPUT
11780   MENUX% = 63
11790   GOSUB MENUGET
11800   CALL DRWRECT(63, 20, 103, 36, 15)
11810   CALL DRWLINE(63, 36, 103, 36, 0)
11820   CALL DRWLINE(103, 20, 103, 36, 0)
11830   CALL BOXPUT(MENUGFX$(3), 73, 24, 0)
11840   MENU% = 2
11850 LABEL SOL3MENU45
11860  IF MENU% <> 2 GOTO SOL3MENU46 : REM -------------- Help opens
11870   CALL DRWBLOCK(63, 20, 103, 36, 14)
11880   CALL DRWRECT(63, 20, 103, 36, 15)
11890   CALL DRWLINE(63, 20, 63, 36, 0)
11900   CALL DRWLINE(63, 20, 103, 20, 0)
11910   CALL BOXPUT(MENUGFX$(1), 74, 24, 0)
11920   CALL BOXGET(GTBOX$, 63, 37, 163, 110)
11930   BLOAD "sol3men3.bmp" OTHERBOX$
11940   CALL BOXPUT(OTHERBOX$, 63, 37, 0)
11950   MENUXX% = 63 : MENU% = 4
11960 LABEL SOL3MENU46
11970 RETURN
11980 REM****************************************************************************
11990 LABEL ITEMGET
12000 CALL BOXGET(ITEMBOX$, IX%, IY%, IX% + 92, IY% + 15)
12010 CALL DRWREVERSE(IX%, IY%, IX% + 92, IY% + 15)
12020 RETURN
12030 REM****************************************************************************
12040 LABEL ITEMPUT
12050 CALL BOXPUT(ITEMBOX$, IX%, IY%, 0)
12060 ITEM% = 0
12070 RETURN
12080 REM****************************************************************************
12090 LABEL MENUGET
12100 CALL BOXGET(MENUBOX$, MENUX%, 20, MENUX% + 40, 36)
12110 RETURN
12120 REM****************************************************************************
12130 LABEL MENUPUT
12140 CALL BOXPUT(MENUBOX$, MENUX%, 20, 0)
12150 MENU% = 0
12160 RETURN
12170 REM****************************************************************************
12180 LABEL MENUCLOSE
12190 CALL BOXPUT(GTBOX$, MENUXX%, 37, 0)
12200 CALL BOXPUT(MENUBOX$, MENUX%, 20, 0)
12210 MENU% = 0 : ITEM% = 0
12220 RETURN
12230 REM****************************************************************************
12240 LABEL SOL3UNDO
12250 IF DECK4% = 0 OR LASTDECK% = 0 GOTO SOL3UNDO5
12260  LASTSUIT% = TURNUPS_SUIT%(DECK4%)
12270  LASTVALUE% = TURNUPS_VALUE%(DECK4%)
12280  IF LASTDECK% <> 1 GOTO SOL3UNDO1
12290   DECK1% = DECK1% + 1
12300   DECKS_SUIT%(1, DECK1%) = LASTSUIT%
12310   DECKS_VALUE%(1, DECK1%) = LASTVALUE%
12320   CALL BOXPUT(CARDBACK$, 5, 43, 0)
12330   GOTO SOL3UNDO3
12340 LABEL SOL3UNDO1
12350  IF LASTDECK% <> 2 GOTO SOL3UNDO2
12360   DECK2% = DECK2% + 1
12370   DECKS_SUIT%(2, DECK2%) = LASTSUIT%
12380   DECKS_VALUE%(2, DECK2%) = LASTVALUE%
12390   CALL BOXPUT(CARDBACK$, 83, 43, 0)
12400   GOTO SOL3UNDO3
12410 LABEL SOL3UNDO2
12420  IF LASTDECK% <> 3 GOTO SOL3UNDO3
12430   DECK3% = DECK3% + 1
12440   DECKS_SUIT%(3, DECK3%) = LASTSUIT%
12450   DECKS_VALUE%(3, DECK3%) = LASTVALUE%
12460   CALL BOXPUT(CARDBACK$, 161, 43, 0)
12470 LABEL SOL3UNDO3
12480  DECK4% = DECK4% - 1
12490  LASTSUIT% = TURNUPS_SUIT%(DECK4%)
12500  LASTVALUE% = TURNUPS_VALUE%(DECK4%)
12510  IF DECK4% <> 0 GOTO SOL3UNDO4 
12520   CALL DRWBLOCK(239, 43, 313, 152, 11)
12530   GOTO SOL3UNDO5
12540 LABEL SOL3UNDO4
12550   CARDNUM% = (LASTSUIT% - 1) * 13 + LASTVALUE%
12560   CALL CARDPUT(239, 43, CARDNUM%)
12570 LABEL SOL3UNDO5
12580 LASTDECK% = 0
12590 RETURN
12600 REM****************************************************************************
12610 SUB DRWPOINT(X%, Y%, COL%)
12620 COLOR COL%
12630 PLOT X%, 479 - Y%
12640 RETURN
12650 REM****************************************************************************
12660 SUB DRWLINE(X1%, Y1%, X2%, Y2%, COL%)
12670 COLOR COL%
12680 PLOT X1%, 479 - Y1% TO X2%, 479 - Y2%
12690 RETURN
12700 REM****************************************************************************
12710 SUB DRWRECT(X1%, Y1%, X2%, Y2%, COL%)
12720 COLOR COL%
12730 PLOT X1%, 479 - Y1% TO X2%, 479 - Y1%
12740 PLOT X2%, 479 - Y1% TO X2%, 479 - Y2%
12750 PLOT X2%, 479 - Y2% TO X1%, 479 - Y2%
12760 PLOT X1%, 479 - Y2% TO X1%, 479 - Y1%
12770 RETURN
12780 REM****************************************************************************
12790 SUB DRWBLOCK(X1%, Y1%, X2%, Y2%, COL%)
12800 COLOR COL%
12810 FOR LIN% = 479 - Y2% TO 479 - Y1%
12820  PLOT X1%, LIN% TO X2%, LIN%
12830 NEXT LIN%
12840 RETURN
12850 REM****************************************************************************
12860 SUB DRWFILL(X%, Y%, CONTOUR%,COL%)
12870 COLOR COL%
12880 FILL X%, 479 - Y%, CONTOUR%
12890 RETURN
12900 REM****************************************************************************
12910 SUB DRWREVERSE(X1%, Y1%, X2%, Y2%)
12920 COLOR 15 : DASH 4
12930 FOR LIN% = 479 - Y2% TO 479 - Y1%
12940  PLOT X1%, LIN% TO X2%, LIN%
12950 NEXT LIN%
12960 DASH 0
12970 RETURN
12980 REM****************************************************************************
12990 SUB DRWTEXT(X%, Y%, STRG$, COL%)
13000 COLOR COL%
13010 SYMBOL X%, 479 - Y%, STRG$ , 1, 1, 0
13020 RETURN
13030 REM****************************************************************************
13040 SUB GTCOLOR(COL%, X%, Y%)
13050 COL% = POINT(X%, 479 - Y%)
13060 RETURN
13070 REM****************************************************************************
13080 SUB BOXGET(BOX$, X1%, Y1%, X2%, Y2%)
13090 GGET BOX$, X1%, 479 - Y2%, X2%, 479 - Y1%
13100 RETURN
13110 REM****************************************************************************
13120 SUB BOXPUT(BOX$, X%, Y%, CM%)
13130 BMPHEIGHT% = DPEEK(DPEEK(PTR(BOX$)) + 22)
13140 GPUT BOX$, X%, 480 - Y% - BMPHEIGHT%, CM%
13150 RETURN
13160 REM****************************************************************************
13170 LABEL MOUSECLEAR
13180 GOSUB MOUSESTATUS
13190 IF LB% GOTO MOUSECLEAR
13200 RETURN
13210 REM****************************************************************************
13220 LABEL MOUSESTATUS
13230 PEN 1, STATUS$
13240 LB% = ASC(STATUS$) AND 1
13250 MOUSEX% = XPEN : MOUSEY% = 479 - YPEN
13260 RETURN
13270 REM****************************************************************************
13280 LABEL MOUSEPAUSE
13290 OMOUSEX% = MOUSEX% : OMOUSEY% = MOUSEY% : OLB% = LB%
13300 LABEL MOUSEPAUSE1
13310 GOSUB MOUSESTATUS
13320 IF MOUSEX% = OMOUSEX% AND MOUSEY% = OMOUSEY% AND LB% = OLB% GOTO MOUSEPAUSE1
13330 RETURN
